#!/usr/bin/perl
#
# GUI code 4 crazysniffer.pl
#
# Last Update: 22.12.2002
#
# Programmed by Bastian Ballmann [ bytebeater@crazydj.de ]
# http://www.crazydj.de
#
# Part of the P.A.T.H project
# http://p-a-t-h.sourceforge.net
#
# This code is licensed under the GPL

###[ Loading Modules ]###

use Tk;
use Tk::FileSelect;


###[ MAIN PART ]###

# Hauptfenster
$top = MainWindow->new();
$top->title('[ Crazy Sniffer ]');
$top->configure(background => 'black', foreground => 'green', borderwidth => 2);

# Frames
$inhalt = $top->Frame->pack(-side => 'top', pady => 5, padx => 10);
$inhalt->configure(background => 'black', foreground => 'green');

$toolbar = $top->Frame->pack(-side => 'bottom', pady => 5, padx => 10);
$toolbar->configure(background => 'black', foreground => 'green', borderwidth => 2);

$pcap_frame = $top->Frame->pack(-side => 'bottom', pady => 5, padx => 10);
$pcap_frame->configure(background => 'black', foreground => 'green');

$ausgabe = $top->Frame->pack(-side => 'bottom', pady => 10, padx => 10);
$ausgabe->configure(background => 'black', foreground => 'green');

# Menubar
$menu = $top->Menu(type => 'Menubar');
$menu->configure(background => 'black', border => 3);
$conf = $menu->cascade('-label' => 'Configure', '-tearoff' => 0);
$conf->configure(background => 'black',
		 foreground => 'green',
		 activebackground => 'black',
		 activeforeground => 'red');

$conf->command('-label' => 'General stuff',
	       background => 'black',
	       foreground => 'green',
	       activebackground => 'black',
	       activeforeground => 'red',
	       command => \&general_config);

$conf->command('-label' => 'Select Sniffin Mode',
	       background => 'black',
	       foreground => 'green',
	       activebackground => 'black',
	       activeforeground => 'red',
	       command => \&sniffin_mode);

$conf->command('-label' => 'Save Config',
	       background => 'black',
	       foreground => 'green',
	       activebackground => 'black',
	       activeforeground => 'red',
	       command => \&save_config);

$conf->command('-label' => 'Load Config',
	       background => 'black',
	       foreground => 'green',
	       activebackground => 'black',
	       activeforeground => 'red',
	       command => \&load_config);

$conf->command('-label' => 'Save Traffic',
	       background => 'black',
	       foreground => 'green',
	       activebackground => 'black',
	       activeforeground => 'red',
	       command => \&save_traffic);

$about = $menu->cascade('-label' => 'About', '-tearoff' => 0);
$about->configure(background => 'black',
		 foreground => 'green',
		 activebackground => 'black',
		 activeforeground => 'red');

$about->command('-label' => 'About this tool',
	       background => 'black',
	       foreground => 'green',
	       activebackground => 'black',
	       activeforeground => 'red',
	       command => \&about);

$top->configure(-menu => $menu, border => 3);


# Labels
$inhalt->Label(text => '[ Crazysniffer -- Programmed by Bastian Ballmann ]',
		background => 'black',
		foreground => 'green',
		border => 0)->pack(pady => 5);

$inhalt->Label(text => '-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-',
		background => 'black',
		foreground => 'green',
		border => 0)->pack();


# Set Pcap Expression
$pcap_frame->Label(text => 'Pcap Expression:',
		   background => 'black',
		   foreground => 'green',
		   border => 0)->pack(pady => 10, side => 'left', padx => 5);
$quick_pcap = $pcap_frame->Entry(background => 'black',
				 foreground => 'green',
				 width => 30)->pack(pady => 10, padx => 5, side => 'left');

# Toolbar
$toolbar->Button(text => 'Start sniffin',
			background => 'black',
			foreground => 'green',
			activebackground => 'black',
			activeforeground => 'red',
			borderwidth => 0,
			border => 0,
			command => \&start_sniffer)->pack(-side => 'left', padx => 10);

$toolbar->Button(text => 'Quit',
			background => 'black',
			foreground => 'green',
			activebackground => 'black',
			activeforeground => 'red',
			borderwidth => 0,
			border => 0,
			command => sub { exit(0); })->pack(-side => 'right', padx => 10);

# Ausgabe
$ausgabe->Label(text => 'Output',
		background => 'black',
		foreground => 'green',
		border => 0)->pack(-side => 'top', pady => 5);

$result = $ausgabe->Scrolled(Text,
			     background => 'black',
			     foreground => 'green',
			     border => 4,
			     width => 100,
			     height => 20)->pack(-side => 'bottom', pady => 5);
$result->configure(scrollbars => 'e');

MainLoop();


###[ Subroutines ]###

# Window to configure general stuff
sub general_config
{
    # New Window
    $cfg_win = $top->Toplevel;
    $cfg_win->title('General Configuration');
    $cfg_win->configure(background => 'black');
    
    # Define Frames
    $cfg_label = $cfg_win->Frame();
    $cfg_label->configure(background => 'black');
    $cfg_dev = $cfg_win->Frame();
    $cfg_dev->configure(background => 'black');
    $cfg_pcap = $cfg_win->Frame();
    $cfg_pcap->configure(background => 'black');
    $cfg_snap = $cfg_win->Frame();
    $cfg_snap->configure(background => 'black');
    $cfg_seq = $cfg_win->Frame();
    $cfg_seq->configure(background => 'black');
    $cfg_flags = $cfg_win->Frame();
    $cfg_flags->configure(background => 'black');
    $cfg_winsize = $cfg_win->Frame();
    $cfg_winsize->configure(background => 'black');
    $cfg_hex = $cfg_win->Frame();
    $cfg_hex->configure(background => 'black');
    $cfg_unten = $cfg_win->Frame();
    $cfg_unten->configure(background => 'black');

    # Content
    $cfg_label->Label(text => 'General Configuration',
		    background => 'black',
		    foreground => 'green',
		    border => 0)->pack(pady => 5);

    $cfg_label->Label(text => '-=-=-=-=-=-=-=-=-=-=-=-=-=-=-',
		    background => 'black',
		    foreground => 'green',
		    border => 0)->pack();


    $cfg_dev->Label(text => 'Network device:',
		    background => 'black',
		    foreground => 'green',
		    border => 0)->pack(-side => 'left', pady => 5, padx => 5, anchor => 'w');
    $device = $cfg_dev->Entry(background => 'black',
			    foreground => 'green')->pack(-side => 'right', pady => 5, padx => 5, anchor => 'e');

    if($args{'i'} eq "")
    {
	$device->insert(0,'eth0');
    }
    else
    {
	$device->insert(0,$args{'i'});
    }

    $cfg_pcap->Label(text => 'Pcap expression:',
		     background => 'black',
		     foreground => 'green',
		     border => 0)->pack(-side => 'left', pady => 5, padx => 5, anchor => 'w');

    $pcap_expr = $cfg_pcap->Entry(background => 'black',
			       foreground => 'green')->pack(-side => 'right', pady => 5, padx => 5, anchor => 'e');

    unless($args{'f'} eq "")
    {
	$device->insert(0,$args{'f'});
    }

    $cfg_snap->Label(text => 'Snaplen:',
		     background => 'black',
		     foreground => 'green',
		     border => 0)->pack(-side => 'left', pady => 5, padx => 5, anchor => 'w');

    $snap = $cfg_snap->Entry(background => 'black',
			  foreground => 'green')->pack(-side => 'right', pady => 5, padx => 5, anchor => 'e');

    if($args{'l'} eq "")
    {
	$snap->insert(0,"2048");
    }
    else
    {
	$snap->insert(0,$args{'l'});
    }

    if($args{'S'} eq "")
    {
	$print_seq = 0;
    }
    else
    {
	$print_seq = $args{'S'};
    }

    $cfg_seq->Label(text => 'Dump Sequence Numbers:',
		    background => 'black',
		    foreground => 'green',
		    border => 0)->pack(-side =>'left', pady => 5, padx => 5);

    $cfg_seq->Radiobutton(variable => \$print_seq,
			  value => 1,
			  text => 'Yes',
			  activebackground => 'black',
			  activeforeground => 'red',
			  background => 'black',
			  foreground => 'green')->pack(-side => 'left', pady => 5, padx => 5);

    $cfg_seq->Radiobutton(variable => \$print_seq,
			  value => 0,
			  text => 'No',
			  activebackground => 'black',
			  activeforeground => 'red',
			  background => 'black',
			  foreground => 'green')->pack(-side => 'left', pady => 5, padx => 5);



    if($args{'F'} eq "")
    {
	$print_flags = 0;
    }
    else
    {
	$print_flags = $args{'F'};
    }

    $cfg_flags->Label(text => 'Dump TCP Flags:',
		    background => 'black',
		    foreground => 'green',
		    border => 0)->pack(-side =>'left', pady => 5, padx => 5);

    $cfg_flags->Radiobutton(variable => \$print_flags,
			  value => 1,
			  text => 'Yes',
			  activebackground => 'black',
			  activeforeground => 'red',
			  background => 'black',
			  foreground => 'green')->pack(-side => 'left', pady => 5, padx => 5);

    $cfg_flags->Radiobutton(variable => \$print_flags,
			  value => 0,
			  text => 'No',
			  activebackground => 'black',
			  activeforeground => 'red',
			  background => 'black',
			  foreground => 'green')->pack(-side => 'left', pady => 5, padx => 5);

    if($args{'W'} eq "")
    {
	$print_winsize = 0;
    }
    else
    {
	$print_winsize = $args{'W'};
    }

    $cfg_winsize->Label(text => 'Dump window size:',
			background => 'black',
			foreground => 'green',
			border => 0)->pack(-side =>'left', pady => 5, padx => 5);

    $cfg_winsize->Radiobutton(variable => \$print_winsize,
			      value => 1,
			      text => 'Yes',
			      activebackground => 'black',
			      activeforeground => 'red',
			      background => 'black',
			      foreground => 'green')->pack(-side => 'left', pady => 5, padx => 5);

    $cfg_winsize->Radiobutton(variable => \$print_winsize,
			      value => 0,
			      text => 'No',
			      activebackground => 'black',
			      activeforeground => 'red',
			      background => 'black',
			      foreground => 'green')->pack(-side => 'left', pady => 5, padx => 5);


    if($args{'x'} eq "")
    {
	$hex = 0;
    }
    else
    {
	$hex = $args{'x'};
    }
    
    $cfg_hex->Label(text => 'Dump payload in hex:',
		    background => 'black',
		    foreground => 'green',
		    border => 0)->pack(-side => 'left', pady => 5, padx => 5);

    $cfg_hex->Radiobutton(variable => \$hex,
			  value => 1,
			  text => 'Yes',
			  activebackground => 'black',
			  activeforeground => 'red',
			  background => 'black',
			  foreground => 'green')->pack(-side => 'left', pady => 5, padx => 5);

    $cfg_hex->Radiobutton(variable => \$hex,
			  value => 0,
			  text => 'No',
			  activebackground => 'black',
			  activeforeground => 'red',
			  background => 'black',
			  foreground => 'green')->pack(-side => 'left', pady => 5, padx => 5);

    $cfg_unten->Button(text => 'OK',
		       background => 'black',
		       foreground => 'green',
		       activebackground => 'black',
		       activeforeground => 'red',
		       border => 0,
		       command => \&save_general_config)->pack(-side => left, pady => 10, padx => 10);

    $cfg_unten->Button(text => 'Close',
		       background => 'black',
		       foreground => 'green',
		       activebackground => 'black',
		       activeforeground => 'red',
		       border => 0,
		       command => sub { $cfg_win->destroy })->pack(-side => left, pady => 10, padx => 10);

    $cfg_label->pack(anchor => 'n', padx => 10, pady => 10);
    $cfg_dev->pack(anchor => 'e', padx => 10);
    $cfg_pcap->pack(anchor => 'e', padx => 10);
    $cfg_snap->pack(anchor => 'e', padx => 10);
    $cfg_seq->pack(anchor => 'e', padx => 10);
    $cfg_flags->pack(anchor => 'e', padx => 10);
    $cfg_winsize->pack(anchor => 'e', padx => 10);
    $cfg_hex->pack(anchor => 'e', padx => 10);
    $cfg_unten->pack(anchor => 's', padx => 10);
}


# Open Window to configure Sniffin Mode
sub sniffin_mode
{
    # New Window
    $mode_win = $top->Toplevel;
    $mode_win->title('Configure Sniffin Mode');
    $mode_win->configure(background => 'black');

    # Define Frames
    $mode_top = $mode_win->Frame();
    $mode_top->configure(background => 'black');
    $mode_normal = $mode_win->Frame();
    $mode_normal->configure(background => 'black');
    $mode_pass = $mode_win->Frame();
    $mode_pass->configure(background => 'black');
    $mode_telnet = $mode_win->Frame();
    $mode_telnet->configure(background => 'black');
    $mode_mail = $mode_win->Frame();
    $mode_mail->configure(background => 'black');
    $mode_bottom = $mode_win->Frame();
    $mode_bottom->configure(background => 'black');

    # Content
    $sniffin_mode = "";

    $mode_top->Label(text => 'Configure Sniffin Mode',
		     background => 'black',
		     foreground => 'green',
		     border => 0)->pack(pady => 5, padx => 10);

    $mode_top->Label(text => '-=-=-=-=-=-=-=-=-=-=-=-',
		     background => 'black',
		     foreground => 'green',
		     border => 0)->pack();

    $mode_normal->Label(text => 'Normal sniffin:',
			background => 'black',
			foreground => 'green',
			border => 0)->pack(pady => 5, padx => 5, -side => 'left');
			
    my $default_mode = $mode_normal->Checkbutton(variable => \$sniffin_mode,
						 offvalue => 'normal',
						 onvalue => 'normal',
						 activebackground => 'black',
						 activeforeground => 'red',
						 background => 'black',
						 foreground => 'green')->pack(-side => 'left', pady => 5, padx => 5);

    $mode_pass->Label(text => 'Password sniffin:',
		      background => 'black',
		      foreground => 'green',
		      border => 0)->pack(pady => 5, padx => 5, -side => 'left');

    my $password_mode = $mode_pass->Checkbutton(variable => \$sniffin_mode,
						offvalue => 'normal',
						onvalue => 'password',
						activebackground => 'black',
						activeforeground => 'red',
						background => 'black',
						foreground => 'green')->pack(-side => 'left', pady => 5, padx => 5);
    
    $mode_telnet->Label(text => 'Telnet sniffin:',
			background => 'black',
			foreground => 'green',
			border => 0)->pack(pady => 5, padx => 5, -side => 'left');

    my $telnet_mode = $mode_telnet->Checkbutton(variable => \$sniffin_mode,
						offvalue => 'normal',
						onvalue => 'telnet',
						activebackground => 'black',
						activeforeground => 'red',
						background => 'black',
						foreground => 'green')->pack(-side => 'left', pady => 5, padx => 5);

    $mode_mail->Label(text => 'Mail sniffin:',
		      background => 'black',
		      foreground => 'green',
		      border => 0)->pack(pady => 5, padx => 5, -side => 'left');
    
    my $mail_mode = $mode_mail->Checkbutton(variable => \$sniffin_mode,
					    offvalue => 'normal',
					    onvalue => 'mail',
					    activebackground => 'black',
					    activeforeground => 'red',
					    background => 'black',
					    foreground => 'green')->pack(-side => 'left', pady => 5, padx => 5);

    if($args{'X'} == 1)
    {
	$password_mode->select();
    }
    elsif($args{'t'} == 1)
    {
	$telnet_mode->select();
    }
    elsif($args{'m'} == 1)
    {
	$mail_mode->select();
    }
    else
    {
	$default_mode->select();
    }

    $mode_bottom->Button(text => 'OK',
			 background => 'black',
			 foreground => 'green',
			 activebackground => 'black',
			 activeforeground => 'red',
			 border => 0,
			 command => \&save_mode_config)->pack(-side => 'left', pady => 10, padx => 10);

    $mode_bottom->Button(text => 'Close',
			 background => 'black',
			 foreground => 'green',
			 activebackground => 'black',
			 activeforeground => 'red',
			 border => 0,
			 command => sub { $mode_win->destroy })->pack(-side => 'left', pady => 10, padx => 10);

    $mode_top->pack(anchor => 'n', padx => 10, pady => 10, side => 'top');
    $mode_normal->pack(anchor => 'e', padx => 10, side => 'top');
    $mode_pass->pack(anchor => 'e', padx => 10, side => 'top');
    $mode_telnet->pack(anchor => 'e', padx => 10, side => 'top');
    $mode_mail->pack(anchor => 'e', padx => 10, side => 'top');
    $mode_bottom->pack(anchor => 's', padx => 10, side => 'bottom');
}


# Reading general config
sub save_general_config
{
    $tmp = $device->get;
    $args{'i'} = $tmp;
    $tmp = $pcap_expr->get;
    $args{'f'} = $tmp;
    $tmp = $snap->get;
    $args{'l'} = $tmp;
 
    if($print_seq)
    {
	$args{'S'} = $print_seq;
    }

    if($print_flags)
    {
	$args{'F'} = $print_flags;
    }

    if($print_winsize)
    {
	$args{'W'} = $print_winsize;
    }

    if($hex)
    {
	$args{'x'} = $hex;
    }

    $cfg_win->destroy;
}


# Read sniffin mode config
sub save_mode_config
{
    if($sniffin_mode eq "password")
    {
	$args{'X'} = 1;
    }
    elsif($sniffin_mode eq "telnet")
    {
	$args{'t'} = 1;
    }
    elsif($sniffin_mode eq "mail")
    {
	$args{'m'} = 1;
    }
    
    $mode_win->destroy;
}

# Save configuration
sub save_config
{
my $f = $top->FileSelect(-directory => ".",
			 -filter => "*");

my $file = $f->Show();

unless($file eq "")
{
    open(S,">$file") || show_error("Cannot write to file $file!\n$!\n");
    print S "device == $args{'i'}\n";
    print S "pcap == $args{'f'}\n";
    print S "snaplen == $args{'l'}\n";
    
    if($args{'S'} eq "")
    {
	print S "print_seq == 0\n";
    }
    else
    {
	print S "print_seq == $args{'S'}\n";
    }

    if($args{'F'} eq "")
    {
	print S "print_flags == 1\n";
    }
    else
    {
	print S "print_flags == $args{'F'}\n";
    }

    if($args{'W'} eq "")
    {
	print S "print_winsize == 1\n";
    }
    else
    {
	print S "print_winsize == $args{'W'}\n";
    }

    if($args{'x'} eq "")
    {
	print S "hex == 0\n";
    }
    else
    {
	print S "hex == $args{'x'}\n";
    }

    if($args{'X'} eq "")
    {
	print S "password == 0\n";
    }
    else
    {
	print S "password == $args{'X'}\n";
    }

    if($args{'t'} eq "")
    {
	print S "telnet == 0\n";
    }
    else
    {
	print S "telnet == $args{'t'}\n";
    }

    if($args{'m'} eq "")
    {
	print S "mail == 0\n";
    }
    else
    {
	print S "mail == $args{'m'}\n";
    }

    close(S);
}
}


# Load configuration
sub load_config
{
my $f = $top->FileSelect(-directory => ".",
			 -filter => "*");

my $file = $f->Show();

unless($file eq "")
{
    # Gibt es die Datei?
    unless(-f $file)
    {
	show_error("Cannot find file $file!\n");
	return;
    }

    my %config = config::readcfg('h',$file);

    $args{'i'} = $config{'device'};
    $args{'f'} = $config{'pcap'};
    $args{'l'} = $config{'snaplen'};

    if($config{'print_seq'} == 1)
    {
	$args{'S'} = $config{'print_seq'};
    }

    if($config{'print_flags'} == 1)
    {
	$args{'F'} = $config{'print_flags'};
    }

    if($config{'print_winsize'} == 1)
    {
	$args{'W'} = $config{'print_winsize'};
    }

    if($config{'hex'} == 1)
    {
	$args{'x'} = $config{'hex'};
    }

    if($config{'password'} == 1)
    {
	$args{'X'} = $config{'password'};
    }

    if($config{'telnet'} == 1)
    {
	$args{'t'} = $config{'telnet'};
    }

    if($config{'mail'} == 1)
    {
	$args{'m'} = $config{'mail'};
    }
}
}

# Show Error Message
sub show_error
{
    my $msg =  shift;
    my $error = $top->Toplevel;
    $error->title('Error');
    $error->configure(background => 'black');

    $error->Label(text => $msg,
		  background => 'black',
		  foreground => 'green',
		  border => '0')->pack(padx => 10, pady => 10, side => 'top');

    $error->Button(text => 'OK',
		   background => 'black',
		   foreground => 'green',
		   activebackground => 'black',
		   activeforeground => 'red',
		   border => 0,
		   command => sub { $error->destroy })->pack(pady => 5, side => 'bottom');
}


# Save traffic
sub save_traffic
{
my $f = $top->FileSelect(-directory => ".",
			 -filter => "*");

$tmp = $f->Show();
unless($tmp eq "")
{
    $args{'w'} = $tmp;
}
}

# Start the sniffer
sub start_sniffer
{
    $tmp = $quick_pcap->get();

    unless($tmp eq "")
    {
	$args{'f'} = $tmp;
    }

    start(%args);
}


# Print about
sub about
{
    $aboutwin = $top->Toplevel;
    $aboutwin->title('About this nice tool');
    $aboutwin->configure(background => 'black');

    $aboutwin->Label(text => 'Crazysniffer - Yet another password and network sniffer',
		     background => 'black',
		     foreground => 'green',
		     border => 0)->pack(pady => 10, padx => 10);

    $aboutwin->Label(text => 'Programmed by Bastian Ballmann',
		     background => 'black',
		     foreground => 'green',
		     border => 0)->pack(padx => 10);

    $aboutwin->Label(text => 'Email: bytebeater@crazydj.de',
		     background => 'black',
		     foreground => 'green',
		     border => 0)->pack(padx => 10);

    $aboutwin->Label(text => 'Web: http://www.crazydj.de',
		     background => 'black',
		     foreground => 'green',
		     border => 0)->pack(padx => 10);

    $aboutwin->Label(text => 'Last Update 22.12.2002',
		     background => 'black',
		     foreground => 'green',
		     border => 0)->pack(pady => 5);

    $downtown = $aboutwin->Frame()->pack(pady => 20);
$closebtn = $downtown->Button(text => 'Just close it!',
			      background => 'black',
			      foreground => 'green',
			      activebackground => 'black',
			      activeforeground => 'red',
			      borderwidth => 5,
			      command => sub { destroy $aboutwin})->pack();
}

1;

