#!/usr/bin/perl
#
# GUI code 4 feed_snort.pl
#
# Last Update: 22.12.2002
#
# Programmed by Bastian Ballmann [ bytebeater@crazydj.de ]
# http://www.crazydj.de
#
# Part of the P.A.T.H project
# http://p-a-t-h.sourceforge.net
#
# This code is licensed under the GPL

###[ Loading Modules ]###

use Tk;


###[ MAIN PART ]###

# Hauptfenster
$top = MainWindow->new();
$top->title('[ Feed Snort ]');
$top->configure(background => 'black', foreground => 'green', borderwidth => 2);

# Frames
$inhalt = $top->Frame->pack(side => 'top', pady => 10, padx => 10);
$inhalt->configure(background => 'black', foreground => 'green');

$configure = $top->Frame->pack(side => 'top', pady => 5, padx => 10);
$configure->configure(background => 'black', foreground => 'green', borderwidth => 2);

$left = $configure->Frame->pack(side => 'left', padx => 10);
$left->configure(background => 'black', foreground => 'green');

$right = $configure->Frame->pack(side => 'right', padx => 10);
$right->configure(background => 'black', foreground => 'green');

$toolbar = $top->Frame->pack(side => 'bottom', pady => 5, padx => 10);
$toolbar->configure(background => 'black', foreground => 'green', borderwidth => 2);

$ausgabe = $top->Frame->pack(side => 'bottom', pady => 15, padx => 10);
$ausgabe->configure(background => 'black', foreground => 'green');

$down = $top->Frame->pack(side => 'bottom', padx => 10, pady => 0);
$down->configure(background => 'black', foreground => 'green');
$d_left = $down->Frame->pack(side => 'left', padx => 10);
$d_left->configure(background => 'black', foreground => 'green');
$d_right = $down->Frame->pack(side => 'right', padx => 10);
$d_right->configure(background => 'black', foreground => 'green');
$p = $d_right->Frame->pack(side => 'top', padx => 10);
$p->configure(background => 'black', foreground => 'green');
$r = $d_right->Frame->pack(side => 'top', padx => 10);
$r->configure(background => 'black', foreground => 'green');
$s = $d_right->Frame->pack(side => 'top', padx => 10);
$s->configure(background => 'black', foreground => 'green');


# Labels
$inhalt->Label(text => '[ Feed SN0RT - Version 0.3 ]',
		background => 'black',
		foreground => 'green',
		border => 0)->pack(pady => 5);

$inhalt->Label(text => '[ Programmed by Bastian Ballmann ]',
		background => 'black',
		foreground => 'green',
		border => 0)->pack(pady => 5);


# Configuration

$left->Label(text => 'Snort Rulefiles:',
	     background => 'black',
	     foreground => 'green',
	     border => 0)->pack(pady => 10, padx => 5);
$rules = $right->Entry(background => 'black',
		       foreground => 'green')->pack(pady => 6);

$rules->insert(end,"/etc/snort/rules");

$left->Label(text => 'Source IP:',
	     background => 'black',
	     foreground => 'green',
	     border => 0)->pack(pady => 10, padx => 5);

$source = $right->Entry(background => 'black',
			    foreground => 'green')->pack(pady => 6);


$left->Label(text => 'Destination IP:',
	     background => 'black',
	     foreground => 'green',
	     border => 0)->pack(pady => 10, padx => 5);

$destination = $right->Entry(background => 'black',
			     foreground => 'green')->pack(pady => 6);


$left->Label(text => 'Default Port:',
	     background => 'black',
	     foreground => 'green',
	     border => 0)->pack(pady => 10, padx => 5);

$port = $right->Entry(background => 'black',
		      foreground => 'green')->pack(pady => 6);

$port->insert(end,"80");

$left->Label(text => 'Delay:',
	     background => 'black',
	     foreground => 'green',
	     border => 0)->pack(pady => 10, padx => 5);

$delay = $right->Entry(background => 'black',
		       foreground => 'green')->pack(pady => 6);

$delay->insert(end,"2");


# Toolbar
$toolbar->Button(text => 'Start feeding',
			background => 'black',
			foreground => 'green',
			activebackground => 'black',
			activeforeground => 'red',
			borderwidth => 0,
			border => 0,
			command => \&getcfg)->pack(side => 'left', padx => 10);

$toolbar->Button(text => 'Quit',
			background => 'black',
			foreground => 'green',
			activebackground => 'black',
			activeforeground => 'red',
			borderwidth => 0,
			border => 0,
			command => sub { exit(0); })->pack(side => 'right', padx => 10);

# Ausgabe
$ausgabe->Label(text => 'Output',
		background => 'black',
		foreground => 'green',
		border => 0)->pack(side => 'top', pady => 10);

$result = $ausgabe->Scrolled(Text,
			     background => 'black',
			     foreground => 'green',
			     border => 2,
			     width => 57,
			     height => 10)->pack(side => 'bottom', pady => 5);
$result->configure(scrollbars => 'e');

MainLoop();


###[ Subroutines ]###

# Readin the config
sub getcfg
{
    $tmp = $rules->get;
    if($tmp eq "")
    {
	show_error("I need at least one Snort rule file!");
	return;
    }
    else
    {
	$args{'r'} = $tmp;
    }

    $tmp = $source->get;

    if(config::check_address($tmp) == 1)
    {
	show_error("Bad address $tmp!\n");
	return;
    }
    else
    {
	$args{'s'} = $tmp;
    }

    $tmp = $destination->get;
    if($tmp eq "")
    {
	show_error("Dont know whom to send the packets...\n");
	return;
    }
    else
    {
	if(config::check_address($tmp) == 1)
	{
	    show_error("Bad ip address $tmp!");
	    return;
	}
	else
	{
	    $args{'h'} = $tmp;
	}
    }

    $args{'p'} = $port->get;
    $args{'w'} = $delay->get;
    start();
}


# Show Error Message
sub show_error
{
    my $msg =  shift;
    my $error = $top->Toplevel;
    $error->title('Error');
    $error->configure(background => 'black');

    $error->Label(text => $msg,
		  background => 'black',
		  foreground => 'green',
		  border => '0')->pack(padx => 10, pady => 10, side => 'top');

    $error->Button(text => 'OK',
		   background => 'black',
		   foreground => 'green',
		   activebackground => 'black',
		   activeforeground => 'red',
		   border => 0,
		   command => sub { $error->destroy })->pack(pady => 5, side => 'bottom');
}

1;

