#
# GUI code 4 icmpredir
#
# Programmed by Stefan Krecher
# Updated by Bastian Ballmann
#
# Last Update: 22.12.2002
#
# This code is licensed under the GPL

$top = MainWindow->new();
$top->title('ICMP-Redirector');
$top->configure(background => 'black');
$top->Label(-text => 'ICMP-Redirector,Stefan Krecher, 2002',
	    background => 'black',
	    foreground => 'green')->pack(-padx => "15p", pady => 10);
$frame_victim = $top->Frame();
$frame_victim->configure(background => 'black');
$frame_alter_gw = $top->Frame();
$frame_alter_gw->configure(background => 'black');
$frame_neuer_gw = $top->Frame();
$frame_neuer_gw->configure(background => 'black');
$frame_ziel_der_route = $top->Frame();
$frame_ziel_der_route->configure(background => 'black');
$frame_buttons = $top->Frame();
$frame_buttons->configure(background => 'black');

#
# Victim
#

$frame_victim->Label(-text => 'Victim ',
		     background => 'black',
		     foreground => 'green')->pack(-side => 'left');
$frame_victim->Entry(
                -width => 20,
                -textvariable => \$victim,
		background => 'black',
		foreground => 'green'
            )->pack(-side => 'left');

#
# alter GW
#

$frame_alter_gw->Label(-text => 'alter GW ',
		       background => 'black',
		       foreground => 'green')->pack(-side => 'left');
$frame_alter_gw->Entry(
		       -width => 20,
		       -textvariable => \$alter_gw,
		       background => 'black',
		       foreground => 'green'
            )->pack(-side => 'left');

#
# neuer GW
#

$frame_neuer_gw->Label(-text => 'neuer GW ',
		       background => 'black',
		       foreground => 'green')->pack(-side => 'left');
$frame_neuer_gw->Entry(
		       -width => 20,
		       -textvariable => \$neuer_gw,
		       background => 'black',
		       foreground => 'green'
            )->pack(-side => 'left');

#
# Ziel der Route
#

$frame_ziel_der_route->Label(-text => 'Ziel der Route ',
			     background => 'black',
			     foreground => 'green')->pack(-side => 'left');
$frame_ziel_der_route->Entry(
			     -width => 20,
			     -textvariable => \$ziel_der_route,
			     background => 'black',
			     foreground => 'green'
            )->pack(-side => 'left');

#
# Die Buttons
#

$frame_buttons->Button(
                        -text => 'Send',
		       background => 'black',
		       foreground => 'green',
		       activebackground => 'black',
		       activeforeground => 'red',
                        -command => sub {  
                            icmp_redir_send();
                        }
                )->pack(-side => 'left', padx => 10, pady => 5);

$frame_buttons->Button(
                        -text => 'Quit',
		       background => 'black',
		       foreground => 'green',
		       activebackground => 'black',
		       activeforeground => 'red',
                        -command => sub { exit 0 }
                )->pack(-side => 'left', padx => 10, pady => 5);

$frame_victim->pack(-anchor => "e", padx => "15");
$frame_alter_gw->pack(-anchor => "e", padx => "15");
$frame_neuer_gw->pack(-anchor => "e", padx => "15");
$frame_ziel_der_route->pack(-anchor => "e", padx => "15");
$frame_buttons->pack(-anchor => "s", pady => 10);

# Die Anwendungsschleife ...
MainLoop;

###[ Subroutines ]###


# Show Error Message
sub show_error
{
    my $msg =  shift;
    my $error = $top->Toplevel;
    $error->title('Error');
    $error->configure(background => 'black');

    $error->Label(text => $msg,
		  background => 'black',
		  foreground => 'green',
		  border => '0')->pack(padx => 10, pady => 10, side => 'top');

    $error->Button(text => 'OK',
		   background => 'black',
		   foreground => 'green',
		   activebackground => 'black',
		   activeforeground => 'red',
		   border => 0,
		   command => sub { $error->destroy })->pack(pady => 5, side => 'bottom');
}

1;
