#!/usr/bin/perl
#
# Just a simple library to start a forked
# child process.
#
# Written by Bastian Ballmann [ bytebeater@crazydj.de ]
# http://www.crazydj.de 
#
# Last Update: 29.07.2002
#
# This code is licensed under the GPL

# Create a child process and start a subroutine
sub mkchild
{
    # Referenz auf die aufzurufende Subroutine
    my $sub = shift;

    # Reference auf einen Hash mit Parametern
    my $args = shift;

    # Fork child process
    my $pid = fork();
    die "Cannot fork a child process!\n$!\n" unless defined $pid;

    if($pid == 0)
    {
	# Call the subroutine
	if(ref($sub))
	{
	    &$sub(%$args);
	}
	# Execute via system() call
	else
	{
	    system("$sub");
	}
    }
}

1;
